#
# spec file for package cvs
#
# Copyright (c) 2017 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           cvs
Version:        1.12.12
Release:        lp152.3.6
Summary:        Concurrent Versions System
License:        GPL-2.0
Group:          Development/Tools/Version Control
Url:            http://www.nongnu.org/cvs/
Source:         http://ftp.gnu.org/non-gnu/%{name}/source/feature/%{version}/%{name}-%{version}.tar.bz2
Source1:        http://www.does-not-exist.org/roessler/cvslock-0.2.tar.gz
Source3:        cvs.sh
Source4:        cvs.csh
Source5:        cvs@.service
Source6:        cvs.socket
Source7:        cvs.target
Source10:       http://cvsbook.red-bean.com/OpenSourceDevWithCVS_2E.tar.gz
Patch0:         cvs.diff
Patch2:         diff-k.possible.patch
Patch5:         cvs-fix_sigpipe_flowcontrol.diff
Patch8:         cvs-use_vitmp.diff
Patch10:        cvs-new-sort-option.diff
Patch11:        cvs-1.11.9-nocsh.patch
Patch12:        03cvs-client-exploit-fix.diff
Patch16:        cvs_readd_l_option.diff
Patch17:        cvs-silence_option_r_warning.diff
Patch18:        cvs-silence_old_format_strings.diff
Patch19:        cvs-1.12.9-null.patch
Patch20:        cvs-format.patch
Patch21:        cvs-useless-asnprintf.diff
Patch22:        cvs-1.12.12_cvsbug-tmp.diff
Patch23:        cvs-1.12.12-rcsfile-sanity.diff
Patch24:        cvs-1.12.12-type_punning.diff
Patch25:        cvs-no_AM_GETTEXT_VERSION.diff
Patch26:        cvs-request_rcs_installation.diff
Patch27:        cvs-fix_printf_format.diff
Patch28:        cvs-gnulib.diff
Patch29:        cvs-CVE-2012-0804.patch
Patch30:        cvs-Bug-1053364-disallow-dash.patch
BuildRequires:  automake
BuildRequires:  gdbm-devel
BuildRequires:  groff
BuildRequires:  krb5-devel
BuildRequires:  openssh
Requires:       openssh
BuildRequires:  zlib-devel
Requires:       %{_bindir}/csh
Requires:       /bin/mktemp
Requires(post): %{install_info_prereq}
Requires(preun): %{install_info_prereq}

%description
CVS is a front-end to the rcs (Revision Control System) included in the
standard Linux distributions. PCL-CVS, an emacs (Emacs) front-end for
CVS, is also included.

%package doc
Summary:        Info pages and Open Source Development with CVS, 2nd Edition Book
Group:          Development/Tools/Version Control
%if 0%{?suse_version} >= 1120
BuildArch:      noarch
%endif

%description doc
Info pages for cvs, an introduction to cvs
(%{_datadir}/%{name}/contrib/intro.doc) and the complete book "Open Source
Development with CVS, 2nd Edition".

%prep
%setup -q -a 1 -a 10
%patch0
%patch2
%patch5
%patch8 -p1
%patch10
%patch11 -p1
%patch12
%patch16
%patch17
%patch18
%patch19
%patch20 -p1
%patch21
%patch22 -p1
%patch23
%patch24
%patch25
%patch26
%patch27
%patch28
%patch29
%patch30 -p1

%build
autoreconf -fvi
export CFLAGS="%{optflags} -pipe -D_GNU_SOURCE -std=gnu99"
%configure \
   --with-external-zlib \
   --with-editor=%{_bindir}/vitmp \
   --with-rsh=ssh
cd cvslock-*
%configure
cd -
make %{?_smp_mflags}
cd cvslock-*
make %{?_smp_mflags}
cd -

%install
%make_install install-info
mkdir -p %{buildroot}%{_sysconfdir}/profile.d
install -m 0644 %{SOURCE3} %{SOURCE4} %{buildroot}%{_sysconfdir}/profile.d
# hack to avoid csh in requires
chmod 644 %{buildroot}%{_datadir}/cvs/contrib/sccs2rcs
mkdir -p %{buildroot}%{_sysconfdir}/xinetd.d
install -p -m 644 -D %{SOURCE5} %{buildroot}%{_unitdir}/cvs\@.service
install -p -m 644 -D %{SOURCE6} %{buildroot}%{_unitdir}/cvs.socket
install -p -m 644 -D %{SOURCE7} %{buildroot}%{_unitdir}/cvs.target
#
# install cvslock
#
cd cvslock-*
%make_install
cd -
#
# documentation
#
mkdir -p %{buildroot}/%{_defaultdocdir}/%{name}/
install -m 0644 */OpenSourceDevWithCVS_2E.pdf \
        %{buildroot}/%{_defaultdocdir}/%{name}/
install -m 0644 contrib/rcs2log.1 %{buildroot}/%{_mandir}/man1

%post doc
%install_info --info-dir=%{_infodir} %{_infodir}/%{name}.info%{ext_info}
%install_info --info-dir=%{_infodir} %{_infodir}/%{name}client.info%{ext_info}

%preun doc
%install_info_delete --info-dir=%{_infodir} %{_infodir}/%{name}.info%{ext_info}
%install_info_delete --info-dir=%{_infodir} %{_infodir}/%{name}client.info%{ext_info}

%pre
%service_add_pre cvs.target cvs.socket

%post
%service_add_post cvs.target cvs.socket

%preun
%service_del_preun cvs.target cvs.socket

%postun
%service_del_postun cvs.target cvs.socket

%files
%defattr(-,root,root)
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/contrib
%config(noreplace) %{_sysconfdir}/profile.d/cvs.sh
%config(noreplace) %{_sysconfdir}/profile.d/cvs.csh
%{_unitdir}/*
%{_bindir}/cvs
%{_bindir}/cvsbug
%{_bindir}/rcs2log
%{_bindir}/cvslock
%{_datadir}/%{name}/contrib/clmerge
%{_datadir}/%{name}/contrib/cln_hist
%{_datadir}/%{name}/contrib/commit_prep
%{_datadir}/%{name}/contrib/cvs2vendor
%{_datadir}/%{name}/contrib/cvs_acls
%{_datadir}/%{name}/contrib/debug_check_log
%{_datadir}/%{name}/contrib/log
%{_datadir}/%{name}/contrib/log_accum
%{_datadir}/%{name}/contrib/mfpipe
%{_datadir}/%{name}/contrib/newcvsroot
%{_datadir}/%{name}/contrib/pvcs2rcs
%{_datadir}/%{name}/contrib/rcs2log
%{_datadir}/%{name}/contrib/rcslock
%{_datadir}/%{name}/contrib/rcs-to-cvs
%{_datadir}/%{name}/contrib/README
%{_datadir}/%{name}/contrib/sandbox_status
%{_datadir}/%{name}/contrib/validate_repo
%attr(755,root,root) %{_datadir}/%{name}/contrib/sccs2rcs
%{_mandir}/man1/*%{ext_man}
%{_mandir}/man5/*%{ext_man}
%{_mandir}/man8/*%{ext_man}

%files doc
%defattr(-,root,root)
%dir %{_defaultdocdir}/%{name}
%{_infodir}/cvs.info-*%{ext_info}
%{_infodir}/cvs.info%{ext_info}
%{_infodir}/cvsclient.info-*%{ext_info}
%{_infodir}/cvsclient.info%{ext_info}
%doc %{_datadir}/%{name}/contrib/intro.doc
%doc %{_defaultdocdir}/%{name}/OpenSourceDevWithCVS_2E.pdf

%changelog
* Fri Aug 11 2017 josef.moellers@suse.com
- Disallow a leading dash in the argument of the "-d" option.
  [bsc#1053364, CVE-2017-12836,
  cvs-Bug-1053364-disallow-dash.patch]
- Changed license to "GPL-2.0"
  see http://cvs.savannah.nongnu.org/viewvc/cvs/ccvs/cvs.spec.in
* Thu Jun 15 2017 mpluskal@suse.com
- Update dependencies:
  * enable kerberos
  * explicitly require ssh
* Thu Jun 15 2017 tchvatal@suse.com
- Update bit with spec-cleaner
- Use proper url for docu and do not recompress:
  * OpenSourceDevWithCVS_2E.tar.gz instead of bz2
- Add systemd socket service to replace the xinetd service
* Fri Mar 22 2013 mmeister@suse.com
- Added url as source.
  Please see http://en.opensuse.org/SourceUrls
* Mon Feb  4 2013 coolo@suse.com
- update license to new format
* Tue Feb 21 2012 pth@suse.de
- Fix typo in the last patch.
* Mon Jan 30 2012 pth@suse.de
- Fix the way CVS reads proxy connection HTTP responses
  (bnc#744059, CVE-2012-0804).
* Fri Dec  2 2011 coolo@suse.com
- add automake as buildrequire to avoid implicit dependency
* Sun Sep 18 2011 jengelh@medozas.de
- Remove redundant tags/sections from specfile
* Mon Sep 20 2010 pth@suse.de
- Fix spec file (bnc#609970).
* Mon Jun 28 2010 jengelh@medozas.de
- use %%_smp_mflags
* Mon May 31 2010 pth@novell.com
- Mention all included documentation (bnc#609970).
- Change URL to http://www.nongnu.org/cvs/.
* Wed Dec 16 2009 jengelh@medozas.de
- Package documentation as noarch
* Tue Apr 28 2009 pth@suse.de
- Make cvs use ssh by default for :ext: transport (bnc#498801).
* Mon Aug 18 2008 schwab@suse.de
- Fix buggy AC_FUNC_MKTIME reimplementation.
* Fri Jun 27 2008 schwab@suse.de
- Fix gnulib macros.
- Fix printf format strings.
* Fri Nov  9 2007 pth@suse.de
- Make rcs2log request the installation of the rcs package if
  /usr/bin/rlog isn't found (#331967).
- Install man page for rcs2log.
- Use rpm macros for path names.
- Fix printf format strings.
- Resync patches.
- Give every patch a cvs- prefix.
- Recompress additional sources with bzip2.
* Tue Jun 19 2007 mkoenig@suse.de
- adjust path to vitmp [#264909]
* Wed May  2 2007 coolo@suse.de
- remove support for susehelp - as cvs is a base pack and susehelp
  isn't really used anymore
* Thu Mar 22 2007 rguenther@suse.de
- add zlib-devel and gdbm-devel BuildRequires
* Wed Mar  7 2007 rguenther@suse.de
- use vitmp as default editor
* Wed Sep 20 2006 rguenther@suse.de
- reference existing file in desktop file
* Mon Sep  4 2006 rguenther@suse.de
- get rid of postfix build dependency by making /sbin/sendmail
  the default
- patch configure.in in use_vitmp.diff because configure gets
  overwritten by autoconf invocation
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Fri Nov  4 2005 od@suse.de
- corrected fix of type punned pointer warning in ls.c:327
* Mon Oct 31 2005 od@suse.de
- fix type punned pointer warning in ls.c:327
* Thu Oct 20 2005 od@suse.de
- fix "cvs up" segfault on corrupt repository file (#129681)
* Tue Aug 30 2005 lnussel@suse.de
- fix /tmp issue in cvsbug (#59450)
* Thu Aug 11 2005 schwab@suse.de
- Don't use [v]asnprintf.
* Wed Aug 10 2005 hvogel@suse.de
- update to version 1.12.12 to get rid of bugs of locales that use
  "GMT" for one of their UTC offsets.  [Bug #86422]
* Sun Feb  6 2005 meissner@suse.de
- added format string markup for 2 functions
* Mon Jan 31 2005 adrian@suse.de
- update to version 1.12.11
* Mon Jan 24 2005 meissner@suse.de
- 0 -> NULL for 1 execl, fixed return type of a
  function.
* Fri Aug 20 2004 adrian@suse.de
- update to version 1.12.9
- remove obsolete security patches
* Fri Jun  4 2004 adrian@suse.de
- update last patch to fix WinCVS support (20040521 version)
- new krahmer+esser security fix for (#39773)
  * error_prog_name "double-free()" (SE)
    CAN-2004-0416
  * argument integer overflow (SK)
    CAN-2004-0417
  * serve_notify() out of bound writes (SK)
    CAN-2004-0418
* Mon May 24 2004 adrian@suse.de
- update to version 1.12.7
  * cleanup obsolete patches
  all work made by Dirk Mueller
* Mon May  3 2004 adrian@suse.de
- expoit-fix for malformed Entry lines. This can be exploited via
  a buffer overflow (#39773)
* Tue Apr 20 2004 adrian@suse.de
- update to cvslock 0.2
- add the cvs book from red-bean into new subpackage -doc
- general cleanup
* Sat Apr 17 2004 mmj@suse.de
- Fix typepunning
* Thu Mar 25 2004 mmj@suse.de
- Add postfix to # neededforbuild
* Mon Mar 22 2004 adrian@suse.de
- apply security fix from Derek
  * CVS pserver client side exploit (#36659)
* Sat Mar 13 2004 adrian@suse.de
- update to new version 1.11.14
  (fixes #35890)
* Thu Jan  8 2004 adrian@suse.de
- update to new version 1.11.11
* Fri Dec 12 2003 fehr@suse.de
- update to new version 1.11.10
* Tue Nov 18 2003 meissner@suse.de
- norootforbuild.
- no longer require tcsh, patch configure.in to
  fall back to /usr/bin/csh directly.
* Thu Oct 16 2003 fehr@suse.de
- update to new version 1.11.9
* Wed Aug 13 2003 fehr@suse.de
- provide /etc/profile.d/cvs.{sh,csh} and make cvs use ssh as
  default (#28702)
* Mon Jul 14 2003 fehr@suse.de
- update to new version 1.11.6
* Wed Jul  9 2003 fehr@suse.de
- use new parameters for sort (#26448)
* Fri May 23 2003 fehr@suse.de
- adopt patches for tmp-race fixes and vitmp usage from OpenWall
  Project
- use zlib from system instead of sources provided with cvs
* Thu Apr 24 2003 ro@suse.de
- fix install_info --delete call and move from preun to postun
* Wed Apr 16 2003 coolo@suse.de
- use BuildRoot
* Wed Mar  5 2003 fehr@suse.de
- add missing file /etc/xinetd.d/cvs (#24671)
* Fri Feb  7 2003 fehr@suse.de
- Use %%install_info macro
* Fri Jan 31 2003 fehr@suse.de
- fix race that may lead to aborted checkouts of large files
  (fix_sigpipe_flowcontrol.diff, #23178)
- allow trailing slashes on directories (e.g. cvs up src/)
  (allow_trailing_dir_slash.diff, #13165)
* Wed Jan 22 2003 fehr@suse.de
- make the feature Checkin-prog/Update-prog configurable
  (default is off)
- update to version 1.11.5
* Mon Jan 20 2003 fehr@suse.de
- disable the commands Checkin-prog/Update-prog in cvs server
  decision was made by SuSE security team (security@suse.de)
* Thu Jan 16 2003 fehr@suse.de
- update to cvs version 1.11.4
- add a patch that fixes a possible double free in cvs server
* Sat Feb 23 2002 kukuk@suse.de
- Don't require tcsh [Bug #13424]
* Fri Feb  8 2002 draht@suse.de
- added patch cvs-1.11.1p1-zlib-zfree.dif against duplicate calls
  of free() in zlib
* Fri Dec 14 2001 fehr@suse.de
- update to new version 1.11.1p1
* Tue May  8 2001 mfabian@suse.de
- bzip2 sources
* Mon Mar 19 2001 fehr@suse.de
- add diff-k.possible.patch which fixes problem when using
  cvs diff -k.. (#6653)
* Fri Feb  9 2001 schwab@suse.de
- Ignore $HOME when running as server (#6293).
* Tue Jan 16 2001 werner@suse.de
- Make last security patch smarter: Ignore not existing temp files
* Wed Jan 10 2001 werner@suse.de
- Add temp file patch of Olaf Kirch
* Mon Sep 25 2000 fehr@suse.de
- changed to new version 1.11
* Fri Aug 25 2000 fehr@suse.de
- changed to new version 1.10.8
* Tue Jul 11 2000 fehr@suse.de
- add tcsh to needforbuild to fix a csh-dependet script
* Mon Mar 13 2000 ro@suse.de
- fixed possible segfault
* Fri Feb 25 2000 kukuk@suse.de
- Move /usr/{info,man} -> /usr/share/{info,man}
* Mon Sep 13 1999 bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Fri Sep  3 1999 fehr@suse.de
- changed to version 1.10.7
* Fri Aug 27 1999 fehr@suse.de
- added cvslock package
* Tue Jul 20 1999 florian@suse.de
- update to 1.10.6, add server patch
* Fri Feb 19 1999 uli@suse.de
- update 1.9.28 -> 1.10.5
- eliminated Makefile.Linux
* Thu Jul 23 1998 werner@suse.de
- use mktemp
* Thu Jul 16 1998 florian@suse.de
- update to version 1.9.28
* Wed Jul 15 1998 werner@suse.de
- Fix possible exploit of rcs2log.sh
* Mon Mar  2 1998 florian@suse.de
- update to version 1.9.24
* Fri Oct 10 1997 florian@suse.de
- update to version 1.9.16
* Wed Apr 30 1997 florian@suse.de
- update to version 1.9.8
* Sun Apr 13 1997 florian@suse.de
- update to new version 1.9.2
